config/routes.rb
# encoding: utf-8
class CourseConstraint
  def matches?(request)
    params = request.path_parameters
    tmp_course = Course.find(params[:id])
    return false if params[:course] != tmp_course.course.parameterize('_')
    true
  end  
end

class MediaConstraint
  def matches?(request)
    obj = request.fullpath.include?('media') ? Media : Audio
    params = request.path_parameters
    tmp = obj.find(params[:id])
    return false if params[:end_date] != tmp.end_date
    true
  end  
end
  
Rails.application.routes.draw do
  root 'welcome#index'
  get 'welcome/index'
  get '/ruby-version' => 'application#ruby_version'
  resources :media do
   collection do
     get 'search', to: 'media#search'
   end 
  end
  resources :audios do
   collection do
     get 'search', to: 'audios#search'
   end 
  end  
  resources :courses do
   collection do
     post 'add_to_course', to: 'courses#add_to_course'
     get 'search', to: 'courses#search'
     get 'clone_course', to: 'courses#clone_course'
     get 'send_email', to: 'courses#send_email'
     get 'archive', to: 'courses#archive'
     get 'archive_search', to: 'courses#archive_search'
     get 'lookup', to: 'courses#lookup'
     get 'unarchive', to: 'courses#unarchive'
     get 'sort', to: 'courses#sort'
   end
  end
  resources :analytics
  resources :licensed_analytics
    
  get 'media/:id/:ds', :to => 'file#show', :constraints => { :ds => /[^\/]+/ }, :as => 'file'  
  get 'courses/:id/:quarter/:year/:course', :to => 'courses#show', constraints: CourseConstraint.new, :as => :course_report
  get 'media/:id/:end_date/:file_name', :to => 'media#view', constraints: MediaConstraint.new, :as => 'video_view'
  get 'audios/:id/:end_date/:file_name', :to => 'audios#view', constraints: MediaConstraint.new, :as => 'audio_view'

  get '/auth/shibboleth', as: :shibboleth
  get '/auth/developer', to: 'users/sessions#developer', as: :developer
  match '/auth/shibboleth/callback' => 'users/sessions#shibboleth', as: :callback, via: [:get, :post]
  get '/users/sign_in', :to => 'users/sessions#new', :as => :new_user_session
  get '/users/sign_out', :to => 'users/sessions#destroy', :as => :destroy_user_session

  # Log out
  get 'logout', :to => 'welcome#logout', as: :logout

  match '*a', :to => 'errors#routing', via: [:get]
end

app/models/audio.rb
#
# @author Vivian <tchu@ucsd.edu>
#
class Audio < ActiveRecord::Base
  has_many :audioreports, dependent: :delete_all
  has_many :courses, through: :audioreports
  validates :track, presence: true
  validates :file_name, presence: true, format: { with: /\A.+(\.mp3)\z/, message: 'must be in mp3' }

  ##
  # Enables copying
  #
  amoeba do
    enable
  end
end

app/models/course.rb
#
# @author Vivian <tchu@ucsd.edu>
#
class Course < ActiveRecord::Base
  has_many :reports, dependent: :delete_all
  has_many :media, through: :reports
  has_many :audioreports, dependent: :delete_all
  has_many :audios, through: :audioreports

  validates :quarter, presence: true
  validates :year, presence: true, length: { maximum: 4 },
                   format: { with: /\A\d{4}\z/, message: 'must be in number format' }
  validates :course, presence: true
  validates :instructor, presence: true

  ##
  # Enables copying
  #
  amoeba do
    enable
    clone [:media]
    clone [:reports]
    clone [:audios]
    clone [:audioreports]
  end
end

app/controllers/audios_controller.rb
#
# @author Vivian <tchu@ucsd.edu>
#
class AudiosController < ApplicationController
  include Dmr::ControllerHelper
  before_action :authorize, only: [:index, :show, :edit, :update, :new, :destroy,
                                   :search]
  before_action :set_audio, only: [:show, :edit, :update, :destroy, :view]

  # GET /audios
  def index
    @audios = Audio.order('created_at DESC').limit(10)
  end

  # GET /audios/1
  def show
    render layout: false
  end

  # GET /view/1/filename

  def view
    render layout: false
  end

  # GET /audios/new
  def new
    @audio = Audio.new
  end

  # GET /audios/1/edit
  def edit; end

  # POST /audios
  def create
    @audio = Audio.new(audio_params)
    @audio.file_name = params[:audio]['file_name'].delete(' ') if params[:audio]['file_name']
    if @audio.save
      redirect_to edit_audio_path(@audio), notice: 'Audio was successfully created.'
    else
      render :new
    end
  end

  # PATCH/PUT /audios/1
  def update
    if @audio.update(audio_params)
      @audio.file_name = params[:audio]['file_name'].delete(' ') if params[:audio]['file_name']
      @audio.save
      redirect_to edit_audio_path(@audio), notice: 'Audio was successfully updated.'
    else
      render :edit
    end
  end

  # DELETE /audios/1
  def destroy
    @audio.destroy
    redirect_to audios_path, notice: 'Audio was successfully destroyed.'
  end

  ##
  # Handles GET search for Audio object
  #
  def search
    return unless params[:search]
    if params[:search].blank?
      redirect_to root_path, alert: 'No text is inputted.'
    else
      @audios = full_search(params[:search], Audio).order(:track).page(params[:page]).per(20)
      create_search_session(@audios)
    end
  end

  def create_search_session(audios)
    @search_count = audios.count
    session[:search] = params[:search]
    session[:search_option] = params[:search_option] if params[:search_option]
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_audio
    @audio = Audio.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def audio_params
    params.require(:audio).permit(:track, :album, :artist, :composer, :call_number, :year, :file_name, :end_date)
  end
end

app/helpers/audios_helper.rb
#
# @author Vivian <tchu@ucsd.edu>
#
require 'net/http'
#
# This module supports the function in Audio controller
#
module AudiosHelper
  def url_exist?(url_string)
    url_string = url_string.delete(' ') if url_string
    url = URI.parse(url_string)
    req = Net::HTTP.new(url.host, url.port)
    req.use_ssl = (url.scheme == 'https')
    req.verify_mode = OpenSSL::SSL::VERIFY_NONE
    path = url.path if url.path.present?
    res = req.request_head(path || '/')
    res.code != '404' # false if returns 404 - not found
  rescue Errno::ENOENT
    false
  end
end

app/views/audios/_audio_viewer.html.erb
<div id="tdr_content_content" style="width:100%;max-width:100%;">
<h3><%= obj.track%></h3>
<%
  if obj
    #secure_token = grab_secure_token_url(obj.file_name, Rails.configuration.secure_token_audio_baseurl) if !obj.nil?
    #audio_base_url = "#{Rails.configuration.secure_token_audio_baseurl}#{obj.file_name}"
    wowzaURL = "#{Rails.configuration.wowza_audio_baseurl}#{obj.file_name}"
  end
%>
<% if wowzaURL %>

  <div id="dmr-audio">Loading the player...</div>

	<script type="text/javascript">
    let newWidth = 1;
    let parent = document.getElementById('dmr-audio').parentElement;
		jwplayer("dmr-audio").setup({
			playlist:
			[{
				sources:
				[
					{file: "https://<%=wowzaURL%>/playlist.m3u8"}					
				]
			}],
      height: 40,
      width: 300,
      analytics: {enabled: false}
		});
    jwplayer().on('ready', function() {
      resize();
      window.onresize = function() {
        resize();
      };    
    });
    function resize() {
      let currentWidth = parent.offsetWidth;
      jwplayer().resize(currentWidth * newWidth, 40);
    }
	</script>

<% end %>
</div>

app/views/audios/_form.html.erb
<div class="required">
  <%= f.text_field :track, label: "Track Title"%>
</div>
<%= f.text_field :album, label: "Album Title" %>
<%= f.text_field :artist, label: "Artist" %>
<%= f.text_field :composer, label: "Composer" %>
<%= f.text_field :call_number, label: "Call Number" %>
<%= f.text_field :year, label: "Year" %>
<div class="required">  
<%= f.text_field :file_name, label: "File Name" %>
</div>
<div class="form-group">
  <% e_date = @audio.end_date ? @audio.end_date : ""%>
  <label class="control-label" for="audio_end_date">End Date</label>
  <input type="text" name="audio[end_date]" id="audio_end_date" value="<%= e_date%>" size="20" placeholder="YYYY-MM-DD" class="enddatepicker form-control" data-date-format="yyyy-mm-dd"/>
</div> 

app/views/audios/_search_result.html.erb
<%= bootstrap_form_for :course, url: add_to_course_courses_path do |f| %>
  <div class="container">
    <div class="row">
      <div class="panel panel-default">
        <table class="table table-striped table-hover table-bordered">
          <thead>
            <tr>
              <th class="col-xs-1" scope="col"><%= label_tag 'check_all', 'check_all', class: "hide-label"%><%= check_box_tag 'check_all',false%></th>
              <th class="col-xs-1" scope="col">Thumbnail</th>
              <th class="col-xs-4" scope="col">Track</th>
              <th class="col-xs-2" scope="col">Album</th>
              <th class="col-xs-1" scope="col">Artist</th>
              <th class="col-xs-1" scope="col">Composer</th>
              <th class="col-xs-2" scope="col">Call Number</th>
              <th class="col-xs-1" scope="col">Year</th>
              <th class="col-xs-1" scope="col">File Name</th>
              <th class="col-xs-1" scope="col" style="min-width:100px;">End Date</th>              
            </tr>
          </thead>
          <tbody>
            <% obj.each do |m| %>
    				<% thumbnailURL = "#{Rails.configuration.audio_file_path}#{m.file_name.gsub('.mp3','.jpg')}"%>
                
    			  <tr>
                <td><fieldset><legend class="hide-label">Type</legend><%= label_tag "media_ids_#{m.id}", 'media_ids[]', class: "hide-label"%>
                <%= check_box_tag 'media_ids[]', m.id, false, id: "media_ids_#{m.id}"%></fieldset></td>
                <td>
    				  <% if url_exist?(thumbnailURL) %>
      				<%=image_tag "#{thumbnailURL}", :alt => '', :class => 'search-thumbnail' %>
    				  <% else %>
       				<%=image_tag "speaker.gif", :alt => '', :class => 'search-thumbnail' %>
    				  <% end %>                
                </td>          
                <td><%= link_to "#{m.track}", edit_audio_path(m.id), 'data-no-turbolink' => true%></td>
                <td><%= m.album %></td>
                <td><%= m.artist %></td>
                <td><%= m.composer %></td>
                <td><%= m.call_number %></td>
                <td><%= m.year %></td>
                <td><%= m.file_name %></td>
                <td><%= m.end_date %></td>
              </tr>
            <% end %>
          <tbody>
        </table>
      </div>
    </div>
  </div>
  <% if @search_count && @search_count > 0%>
    <%= render :partial => 'shared/display_bottom_paginate' , :locals => {:obj => obj}%>
  <% end %>
 <div class="text-center">
    <%= hidden_field_tag 'type', 'audio' %>
    <%= f.primary "Add to Course List"%>    
    <%= link_to "Create New Audio Record", new_audio_path, class: "btn btn-primary"%>
    <%= f.primary "Delete Selected Records", data: { confirm: 'Are you sure?' }%>
  </div>  
<% end %>

app/views/audios/edit.html.erb
<div class="container">
  <div class="row">
    <div class="col-sm-10">
	  <div class="col-xs-9 col-sm-9">
	    <h3>Audio Record Core Data</h3>
	    <%= render :partial => 'shared/error_messages' , :locals => {:obj => @audio}%>
	    <p class="required">* Required field </p>
	  
	    <%= bootstrap_form_for @audio, :required=>true do |f| %>
	      <%= render :partial => 'form' , :locals => {:f => f}%>
	      <%= f.primary "Save"%>
	      <%= link_to "Play File", @audio, class: "btn btn-primary", :onclick=>"window.open(this.href,'video_player', 'height=600, width=600');return false;" %>
	      <% if @audio.end_date && !@audio.end_date.blank?%>
	        <%#= link_to "URL", audio_view_path(@audio), class: "btn btn-primary", 'data-no-turbolink' => true , :onclick=>"window.open(this.href,'video_player', 'height=700, width=1000');return false;" %>
            <%= link_to "URL", audio_view_path(@audio), class: "btn btn-primary", 'data-no-turbolink' => true, :onclick=>"alert(this.href);return false;" %>
	      <% end %>
	      <%= link_to "Delete", @audio, method: :delete, data: { confirm: 'Are you sure?' }, class: "btn btn-primary"%>
	      <%= link_to "Add to Course List", add_to_course_courses_path(:course, :media_ids => ["#{@audio.id}"], :type => 'audio'), :method=> :post, class: "btn btn-primary"%>	     
	      <%= link_to "Return to Search Results", search_audios_path(:search => session[:search]), class: "btn btn-primary"%>
	    <%end%>	    	      
	  </div>
      <%= render :partial => 'shared/thumbnail' , :locals => {:obj => @audio}%>
    </div>
  </div>
</div>

app/views/audios/index.html.erb
<div class="text-center"><h3>Listing Audio</h3></div>
<%= render :partial => 'search_result' , :locals => {:obj => @audios}%>

app/views/audios/new.html.erb
<div class="container">
  <div class="row">
	<div class="object-panel">
	  <h3>New Audio Record Core Data</h3>
	  <%= render :partial => 'shared/error_messages' , :locals => {:obj => @audio}%>
	  <p class="required">* Required field </p>
	
	  <%= bootstrap_form_for :audio, url: audios_path do |f| %>
        <%= render :partial => 'form' , :locals => {:f => f}%>
        <div class="center-block">
          <%= f.primary "Save"%>
	      <input class="btn btn-primary" type="reset" value="Cancel"/>
	    </div>
	  <% end %>
	</div>
  </div>
</div>

app/views/audios/search.html.erb
<% if @search_count && @search_count > 0%>
  <%= render :partial => 'shared/display_paginate' , :locals => {:obj => @audios}%>
  <%= render :partial => 'search_result' , :locals => {:obj => @audios}%> 
<% elsif @search_count && @search_count == 0%>
  <div class="text-center">There were no results for the search: "<%= params[:search]%>"</div>
<% end %>

app/views/audios/show.html.erb
<!DOCTYPE html>
<html lang="en">
<%= render :partial => 'shared/head'%>
<body>
<div class="container-fluid">
  <%= render :partial => 'audio_viewer' , :locals => {:obj => @audio}%>  
</div>
</body>
</html>

app/views/audios/view.html.erb
<!DOCTYPE html>
<html lang="en">
<%= render :partial => 'shared/report_header'%>
<body>
  <%= render :partial => 'shared/report_menu'%>
  <div id="tdr_content" class="tdr_fonts" style="width:80%;margin-left:auto;margin-right:auto;">  
    
  <%= render :partial => 'audio_viewer' , :locals => {:obj => @audio}%><br/><br/>          
  <%= render :partial => 'shared/report_footer'%>
  
</body>
</html>